//
// DO WHAT YOU WANT TO PUBLIC LICENSE
//
// Copyright (C) 2012 James Custer
//
// Everyone is permitted to copy and distribute verbatim or modified
// copies of this license document.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law.
//
// TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
//
// 0. You just DO WHAT YOU WANT TO.
//

//-----------------------------------------------------------------------------
// An example of an MPI program using broadcast.
//-----------------------------------------------------------------------------

#include <iostream>

#include <boost/mpi.hpp>

int main(int argc, char* argv[])
{
  boost::mpi::environment env(argc, argv);
  boost::mpi::communicator world;

  int root_process = 0;
  int value = 0;
  if (world.rank() == root_process)
    value = 1;

  std::cout << "Before broadcast --> rank: " << world.rank() << " " << "value: " << value << std::endl;

  boost::mpi::broadcast(world, value, root_process);

  std::cout << "After broadcast  --> rank: " << world.rank() << " " << "value: " << value << std::endl;
}
