//
// DO WHAT YOU WANT TO PUBLIC LICENSE
//
// Copyright (C) 2012 James Custer
//
// Everyone is permitted to copy and distribute verbatim or modified
// copies of this license document.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law.
//
// TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
//
// 0. You just DO WHAT YOU WANT TO.
//

//-----------------------------------------------------------------------------
// An example of an MPI program using gather.
//-----------------------------------------------------------------------------

#include <iostream>
#include <vector>

#include <boost/mpi.hpp>

int main(int argc, char* argv[])
{
  boost::mpi::environment env(argc, argv);
  boost::mpi::communicator world;

  int root_process = 1;
  int value = world.rank();
  std::vector<int> all_values;

  std::cout << "Before gather --> rank: " << world.rank() << " " << "value: " << value << std::endl;

  boost::mpi::gather(world, value, all_values, root_process);

  if (world.rank() == root_process)
    for (unsigned i = 0; i < all_values.size(); ++i)
      std::cout << "After gather  --> rank: " << world.rank() << " all_values[" << i << "]: " << all_values[i] << std::endl;
}
