//
// DO WHAT YOU WANT TO PUBLIC LICENSE
//
// Copyright (C) 2012 James Custer
//
// Everyone is permitted to copy and distribute verbatim or modified
// copies of this license document.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law.
//
// TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
//
// 0. You just DO WHAT YOU WANT TO.
//

//-----------------------------------------------------------------------------
// An example of an MPI program using reduce.
//-----------------------------------------------------------------------------

#include <iostream>
#include <functional>
#include <vector>

#include <boost/mpi.hpp>

int main(int argc, char* argv[])
{
  boost::mpi::environment env(argc, argv);
  boost::mpi::communicator world;

  int root_process = 1;
  int value = world.rank();

  std::cout << "Before reduce --> rank: " << world.rank() << " " << "value: " << value << std::endl;

  if (world.rank() == root_process)
  {
    int sum;
    boost::mpi::reduce(world, value, sum, std::plus<int>(), root_process);
    std::cout << "sum: " << sum << std::endl;
  }
  else
    boost::mpi::reduce(world, value, std::plus<int>(), root_process);
}
