//
// DO WHAT YOU WANT TO PUBLIC LICENSE
//
// Copyright (C) 2012 James Custer
//
// Everyone is permitted to copy and distribute verbatim or modified
// copies of this license document.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law.
//
// TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
//
// 0. You just DO WHAT YOU WANT TO.
//

//-----------------------------------------------------------------------------
// An example of an MPI program using scatter.
//-----------------------------------------------------------------------------

#include <iostream>
#include <vector>

#include <boost/mpi.hpp>

int main(int argc, char* argv[])
{
  boost::mpi::environment env(argc, argv);
  boost::mpi::communicator world;

  int root_process = 1;
  int value;
  std::vector<int> values_to_scatter;
  if (world.rank() == root_process)
  {
    values_to_scatter.resize(world.size());
    for (int i = 0; i < world.size(); ++i)
    {
      values_to_scatter[i] = i;

      std::cout << "Before scatter --> rank: " << world.rank() << " values_to_scatter[" << i << "]: " << values_to_scatter[i] << std::endl;
    }
  }

  boost::mpi::scatter(world, values_to_scatter, value, root_process);

  std::cout << "After scatter  --> rank: " << world.rank() << " " << value << std::endl;
}
