#!/usr/bin/env python

#
# DO WHAT YOU WANT TO PUBLIC LICENSE
#
# Copyright (C) 2012 James Custer
#
# Everyone is permitted to copy and distribute verbatim or modified
# copies of this license document.
#
# This program is free software. It comes without any warranty, to
# the extent permitted by applicable law.
#
# TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
#
# 0. You just DO WHAT YOU WANT TO.
#

import matplotlib
matplotlib.use('Agg')
from matplotlib import *
from numpy import *
from matplotlib.pyplot import *

rc('text', usetex=True)
rc('font', family='serif')
rc('font', size=11)
matplotlib.rcParams['text.latex.preamble']=[r"\usepackage{amsmath}"]

fig = figure(1, figsize=(4,4))
ax = fig.add_subplot(111)
xlabel('Number of Cores')
ylabel('Speedup')
title("MPI Implementation")

filename   = 'timings'
imported_array = loadtxt(filename)
imported_array[:,1] = imported_array[0,1] / imported_array[:,1]
ax.plot(imported_array[:,0], imported_array[:,1], 'ko', label='data')
ax.plot(range(len(imported_array)+2), range(len(imported_array)+2), 'k-', label='ideal')

legend = ax.legend(numpoints=1,loc='upper left')

tight_layout(1)

savefig('speedup.pdf')
